<template>
  <div id="uploads-panel">
    <b-form-file
        id="uploads_input"
        :multiple="false"
        v-model="vmodelFiles"/>
    <b-table striped hover :items="displayFiles" placeholder="Upload a file..."/>
  </div>
</template>

<script>

export default {
    name: 'uploads-panel',

    // This prop is the value that we are emitting to our parent
    // for v-model to work.
    props: {
        'handler': Object,
        'function': String,
        'upload': Boolean
    },

    data: function() {
        return {
            vmodelFiles: null
        }
    },

    watch: {
        upload: function() {
            // Upload our batch of files when told to do so
            if (this.upload) {
                this.handleUploads()
            }
        }
    },

    methods: {
        getRawFiles: function () {
            var rawFiles = []
            if (this.vmodelFiles instanceof Array) {
                return this.vmodelFiles
            }
            if (this.vmodelFiles) {
                rawFiles = [ this.vmodelFiles ]
            }
            return rawFiles
            
        },

        handleUploads: async function() {
            // Since we cannot emit Javascript File objects, we have to instead
            // pass them to a function that our handler can upload as necessary
            var rawFiles = this.getRawFiles()

            if (!this.handler || !this.function) {
                console.log('UploadsPanel.vue: Error getting handler or function from prop!')
                return
            }

            try {
                await this.handler[this.function](rawFiles)
            } catch (e) {
                console.log(e)
                alert(e)
            }

            this.$emit('upload-done')
        }
    },

    computed: {
        displayFiles: function() {
            var rawFiles = this.getRawFiles()
            var files = []
            for (var i = 0; i < rawFiles.length; i++) {
                files.push({
                    "Name": rawFiles[i].name, 
                    "Size": rawFiles[i].size,
                })
            }
            return files
        }
    }
}
</script>
